# bcond default logic is nicely backwards...
%bcond_without tcl
%bcond_with static
%bcond_with check

%define realname sqlite
%define realver 3230000
%define docver  3230000
%define rpmver 3.2300


%define	major 0
%define libname	%mklibname %{name}_ %{major}
%define develname	%mklibname %{name} -d
%define staticdevelname	%mklibname %{name} -d -s

Summary: C library that implements an embeddable SQL database engine
Name:	 sqlite3
Version: %{rpmver}
Release: %mkrel 1
License: Public Domain
Group:	 System/Libraries
URL:	 http://www.sqlite.org/
Source0: http://www.sqlite.org/2013/sqlite-src-%{realver}.zip
Source1: http://www.sqlite.org/2013/sqlite-doc-%{docver}.zip

Patch1: sqlite-3.6.23-lemon-system-template.patch
Patch2: sqlite-3.7.7.1-stupid-openfiles-test.patch
Patch3: sqlite-3.12.2-no-malloc-usable-size.patch
Patch4: sqlite-3.8.0-percentile-test.patch
Patch6: sqlite-3.8.10.1-tcl-regress-tests.patch
Patch7: sqlite-3.16-datetest-2.2c.patch
Patch8: sqlite-3.18.0-sync2-dirsync.patch
BuildRequires:	pkgconfig(ncurses)

BuildRequires: ncurses-devel readline-devel glibc-devel
# libdl patch needs
BuildRequires: autoconf
BuildRequires:	chrpath
BuildRequires:	ncurses-devel
BuildRequires:	readline-devel
%if %{with tcl}
BuildRequires: tcl
BuildRequires: tcl-devel
%{!?tcl_version: %global tcl_version 8.5.10}
%{!?tcl_sitearch: %global tcl_sitearch %{_libdir}/tcl%{tcl_version}}
%endif

%description
SQLite is a C library that implements an embeddable SQL database
engine. Programs that link with the SQLite library can have SQL
database access without running a separate RDBMS process. The
distribution comes with a standalone command-line access program
(sqlite) that can be used to administer an SQLite database and
which serves as an example of how to use the SQLite library.


%package -n %{libname}
Summary:	C library that implements an embeddable SQL database engine
Group:		System/Libraries

%description -n	%{libname}
SQLite is a C library that implements an embeddable SQL database
engine. Programs that link with the SQLite library can have SQL
database access without running a separate RDBMS process. The
distribution comes with a standalone command-line access program
(sqlite) that can be used to administer an SQLite database and
which serves as an example of how to use the SQLite library.

This package contains the shared libraries for %{name}

%package -n %{develname}
Summary:	Development library and header files for the %{name} library
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname %{name}_ %{major} -d

%description -n	%{develname}
SQLite is a C library that implements an embeddable SQL database
engine. Programs that link with the SQLite library can have SQL
database access without running a separate RDBMS process. The
distribution comes with a standalone command-line access program
(sqlite) that can be used to administer an SQLite database and
which serves as an example of how to use the SQLite library.

This package contains the static %{libname} library and its header
files.

%package -n %{staticdevelname}
Summary:	Static development library for the %{name} library
Group:		Development/Libraries
Requires:	%{develname} = %{version}-%{release}
Provides:	lib%{name}-static-devel = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}
Obsoletes:	%mklibname %{name}_ %{major} -d -s

%description -n	%{staticdevelname}
SQLite is a C library that implements an embeddable SQL database
engine. Programs that link with the SQLite library can have SQL
database access without running a separate RDBMS process. The
distribution comes with a standalone command-line access program
(sqlite) that can be used to administer an SQLite database and
which serves as an example of how to use the SQLite library.

This package contains the static %{libname} library.

%package tools
Summary:	Command line tools for managing the %{libname} library
Group:		Databases
Requires:	%{libname} = %{version}-%{release}

%description tools
SQLite is a C library that implements an embeddable SQL database
engine. Programs that link with the SQLite library can have SQL
database access without running a separate RDBMS process. The
distribution comes with a standalone command-line access program
(sqlite) that can be used to administer an SQLite database and
which serves as an example of how to use the SQLite library.

This package contains command line tools for managing the
%{libname} library.

%package -n lemon
Summary: A parser generator
Group: Databases

%description -n lemon
Lemon is an LALR(1) parser generator for C or C++. It does the same
job as bison and yacc. But lemon is not another bison or yacc
clone. It uses a different grammar syntax which is designed to reduce
the number of coding errors. Lemon also uses a more sophisticated
parsing engine that is faster than yacc and bison and which is both
reentrant and thread-safe. Furthermore, Lemon implements features
that can be used to eliminate resource leaks, making is suitable for
use in long-running programs such as graphical user interfaces or
embedded controllers.

%if %{with tcl}
%package tcl
Summary: Tcl module for the sqlite3 embeddable SQL database engine
Group: Development/Other
Requires: %{name}-tools = %{version}-%{release}
Requires: tcl >= %{tcl_version}
Obsoletes: tcl-sqlite3 < %{version}
Provides: tcl-sqlite3 = %{version}-%{release}

%description tcl
This package contains the tcl modules for %{name}.

%package analyzer
Summary: An analysis program for sqlite3 database files
Group: Development/Tools
Requires: %{name}-tcl = %{version}-%{release}
Requires: tcl >= %{tcl_version}

%description analyzer
This package contains the analysis program for %{name}.
%endif

%prep
%setup -q -a1 -n %{realname}-src-%{realver}
%patch1 -p1 -b .lemon-system-template
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%ifarch %{ix86}
%patch7 -p1
%endif
%patch8 -p1

# Remove cgi-script erroneously included in sqlite-doc-3070500
rm -f %{name}-doc-%{realver}/search

%build
autoreconf -fi
export CFLAGS="%{optflags} -DSQLITE_ENABLE_FTS3_TOKENIZER -DSQLITE_ENABLE_COLUMN_METADATA=1 -DSQLITE_DISABLE_DIRSYNC=1 -DSQLITE_ENABLE_FTS3=3 -DSQLITE_ENABLE_RTREE=1 -DSQLITE_SECURE_DELETE=1 -DSQLITE_ENABLE_UNLOCK_NOTIFY=1 -DSQLITE_ENABLE_DBSTAT_VTAB=1 -DSQLITE_ENABLE_ICU=1 -Wall -fno-strict-aliasing"
export LDFLAGS="%{ldflags} `icu-config --ldflags`"
%configure2_5x %{!?with_tcl:--disable-tcl} \
           --enable-threadsafe \
           --enable-load-extension \
           %{?with_tcl:TCLLIBDIR=%{tcl_sitearch}/sqlite3}

sed -i '/HAVE_MALLOC_USABLE_SIZE/d' config.h

# rpath removal
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make

# Build sqlite3_analyzer
# depends on tcl
%if %{with tcl}
make %{?_smp_mflags} sqlite3_analyzer
%endif


%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_mandir}/man1

make DESTDIR=${RPM_BUILD_ROOT} install

install -D -m0644 sqlite3.1 $RPM_BUILD_ROOT/%{_mandir}/man1/sqlite3.1
install -D -m0755 lemon $RPM_BUILD_ROOT/%{_bindir}/lemon
install -D -m0644 tool/lempar.c $RPM_BUILD_ROOT/%{_datadir}/lemon/lempar.c

%if %{with tcl}
# fix up permissions to enable dep extraction
chmod 0755 ${RPM_BUILD_ROOT}/%{tcl_sitearch}/sqlite3/*.so
# Install sqlite3_analyzer
install -D -m0755 sqlite3_analyzer $RPM_BUILD_ROOT/%{_bindir}/sqlite3_analyzer
%endif

%makeinstall_std

rm -f %{buildroot}%{_libdir}/*.la

chrpath -d %{buildroot}%{_bindir}/*

%if %{with check}
%check
make test
%endif

%clean
rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/lib*.so.%{major}*

%files -n %{develname}
%defattr(-,root,root)
%attr(0644,root,root) %{_includedir}/*.h
%{_libdir}/lib*.so
%attr(0644,root,root) %{_libdir}/pkgconfig/*.pc

%files -n %{staticdevelname}
%defattr(-,root,root)
%{_libdir}/lib*.a

%files tools
%defattr(-,root,root)
%{_bindir}/sqlite3
%{_mandir}/man1/*

%files -n lemon
%defattr(-, root, root)
%{_bindir}/lemon
%{_datadir}/lemon

%if %{with tcl}
%files tcl
%defattr(-, root, root)
%{tcl_sitearch}/sqlite3

%files analyzer
%defattr(-, root, root)
%{_bindir}/sqlite3_analyzer
%endif


%changelog
* Mon Apr 02 2018 bb2 <bb2> - 3.2300-1pclos2018
- new version

* Sun Nov 05 2017 bb2 <bb2> - 3.2100-2pclos2017
- rebuild against updates

* Tue Oct 31 2017 bb2 <bb2> - 3.2100-1pclos2017
- new version

* Tue Aug 22 2017 bb2 <bb2> - 3.2000-1pclos2017
- new version

* Tue Aug 15 2017 bb2 <bb2> - 3.1070-2pclos2017
- rebuild against updates

* Wed Mar 01 2017 bb2 <bb2> - 3.17.0-1pclos2017
- new version

* Sun May 01 2016 bb <bb> 3.12.2-3pclos2016
- add for geary -DSQLITE_ENABLE_FTS3_TOKENIZER

* Tue Apr 26 2016 bb <bb> 3.12.2-2pclos2016
- rebuild for new icu

* Thu Apr 21 2016 bb <bb> 3.12.2-1pclos2016
- update

